///////////////////////////////////////////////////////////////////////////////////
//^`
///////////////////////////////////////////////////////////////////////////////////
struct VS_OUT
{
    float4 Position : POSITION;
    float3 Light : TEXCOORD0;
    float3 Normal : TEXCOORD1;
    float3 View : TEXCOORD2;
};

///////////////////////////////////////////////////////////////////////////////////
//O[o
///////////////////////////////////////////////////////////////////////////////////
float4x4 matWVP; 
float4x4 matWorld; 
float4 vecLightDir;
float4 vecEye; 
float4 Diffuse=float4(0,0,0,0); 

///////////////////////////////////////////////////////////////////////////////////
//o[ebNXEVF[_[
///////////////////////////////////////////////////////////////////////////////////
VS_OUT VS(float4 Pos : POSITION, float3 Normal : NORMAL)
{
    VS_OUT Out = (VS_OUT)0; 
    Out.Position = mul(Pos, matWVP); 
    Out.Light = vecLightDir;           
    float3 PosWorld = normalize(mul(Pos, matWorld)); 
    Out.View = vecEye - PosWorld;      
    Out.Normal = mul(Normal, matWorld); 

	return Out;
}
///////////////////////////////////////////////////////////////////////////////////
//sNZEVF[_[
///////////////////////////////////////////////////////////////////////////////////
float4 PS(VS_OUT In) : COLOR
{
	float3 Normal = normalize(In.Normal);
    float3 LightDir = normalize(In.Light);
    float3 ViewDir = normalize(In.View); 
    float4 NL = saturate(dot(Normal, LightDir)); 
    
    float3 Reflect = normalize(2 * NL * Normal - LightDir); //˃xNǧʂ
    float4 specular = pow(saturate(dot(Reflect, ViewDir)), 1);     
    
    float4 VN=dot(ViewDir,Normal);
    float4 Rime=pow(float4(1,1,1,1)*(1-VN),1);//RimeF\ʂ̑ij	

    return Diffuse * NL + specular +Rime; //ʏAƖfƌΊ̍܂߂܂AȒP̂ߏ܂B
}

///////////////////////////////////////////////////////////////////////////////////
// eNjbN
///////////////////////////////////////////////////////////////////////////////////
technique tecRime
{
    pass p0
    {
        VertexShader = compile vs_2_0 VS();
        PixelShader  = compile ps_2_0 PS();
    }
}